import { Day } from '../../../core/_old/types/day.enum';
import { CreateAdRequestDTO } from '../../../interface/commands/create-ad.request.dto';
import { ScheduleDTO } from '../../../core/dtos/schedule.dto';
import { FrequencyNormalizer } from '../../../core/entities/frequency.normalizer';
import { Frequency } from '../../../interface/commands/frequency.enum';

describe('recurrent normalizer transformer for punctual ad ', () => {
  const frequencyNormalizer = new FrequencyNormalizer();
  it('should transform punctual ad into recurrent ad', () => {
    const punctualAd: CreateAdRequestDTO = {
      userUuid: 'cb7ad514-ad0d-463f-9041-b79f9afe33aa',
      frequency: Frequency.PUNCTUAL,
      departureDate: new Date('2023-03-05T12:39:39+02:00'),
      waypoints: [
        {
          position: 0,
          lon: 48.68944505415954,
          lat: 6.176510296462267,
          houseNumber: '5',
          street: 'Avenue Foch',
          locality: 'Nancy',
          postalCode: '54000',
          country: 'France',
        },
        {
          position: 1,
          lon: 48.8566,
          lat: 2.3522,
          locality: 'Paris',
          postalCode: '75000',
          country: 'France',
        },
      ],
    };
    // expect(frequencyNormalizer.fromDateResolver(punctualAd)).toStrictEqual(
    //   new Date('2023-03-05T12:39:39Z'),
    // );
    // expect(frequencyNormalizer.toDateResolver(punctualAd)).toStrictEqual(
    //   new Date('2023-03-05T12:39:39Z'),
    // );
    // expect(
    //   frequencyNormalizer.scheduleResolver(punctualAd, Day.mon),
    // ).toBeUndefined();
    // expect(
    //   frequencyNormalizer.scheduleResolver(punctualAd, Day.tue),
    // ).toBeUndefined();
    // expect(
    //   frequencyNormalizer.scheduleResolver(punctualAd, Day.wed),
    // ).toBeUndefined();
    // expect(
    //   frequencyNormalizer.scheduleResolver(punctualAd, Day.thu),
    // ).toBeUndefined();
    // expect(
    //   frequencyNormalizer.scheduleResolver(punctualAd, Day.fri),
    // ).toBeUndefined();
    // expect(
    //   frequencyNormalizer.scheduleResolver(punctualAd, Day.sat),
    // ).toBeUndefined();
    expect(frequencyNormalizer.scheduleResolver(punctualAd, Day.sun)).toBe(
      '12:39',
    );
  });
  // it('should leave recurrent ad as is', () => {
  //   const recurrentAd: CreateAdRequest = {
  //     userUuid: '',
  //     frequency: Frequency.RECURRENT,
  //     schedule: {
  //       mon: '08:30',
  //       tue: '08:30',
  //       wed: '09:00',
  //       fri: '09:00',
  //     },
  //     waypoints: [],
  //   };
  //   expect(frequencyNormalizer.fromDateResolver(recurrentAd)).toBe(
  //     recurrentAd.departure,
  //   );
  //   expect(frequencyNormalizer.toDateResolver(recurrentAd)).toBe(
  //     recurrentAd.departure,
  //   );
  //   expect(frequencyNormalizer.scheduleResolver(recurrentAd, Day.mon)).toBe(
  //     recurrentAd.schedule.mon,
  //   );
  //   expect(frequencyNormalizer.scheduleResolver(recurrentAd, Day.tue)).toBe(
  //     recurrentAd.schedule.tue,
  //   );
  //   expect(frequencyNormalizer.scheduleResolver(recurrentAd, Day.wed)).toBe(
  //     recurrentAd.schedule.wed,
  //   );
  //   expect(frequencyNormalizer.scheduleResolver(recurrentAd, Day.thu)).toBe(
  //     recurrentAd.schedule.thu,
  //   );
  //   expect(frequencyNormalizer.scheduleResolver(recurrentAd, Day.fri)).toBe(
  //     recurrentAd.schedule.fri,
  //   );
  //   expect(frequencyNormalizer.scheduleResolver(recurrentAd, Day.sat)).toBe(
  //     recurrentAd.schedule.sat,
  //   );
  //   expect(frequencyNormalizer.scheduleResolver(recurrentAd, Day.sun)).toBe(
  //     recurrentAd.schedule.sun,
  //   );
  // });
  // it('should pass for each day of the week of a deprarture ', () => {
  //   const punctualAd: CreateAdRequest = {
  //     userUuid: '',
  //     frequency: Frequency.PUNCTUAL,
  //     departure: undefined,
  //     schedule: {} as ScheduleDTO,
  //     waypoints: [],
  //   };
  //   punctualAd.departure = new Date('05-01-2023 ');
  //   expect(frequencyNormalizer.scheduleResolver(punctualAd, Day.mon)).toBe(
  //     '00:00',
  //   );
  //   punctualAd.departure = new Date('05-02-2023 06:32:45');
  //   expect(frequencyNormalizer.scheduleResolver(punctualAd, Day.tue)).toBe(
  //     '06:32',
  //   );
  //   punctualAd.departure = new Date('05-03-2023 10:21');
  //   expect(frequencyNormalizer.scheduleResolver(punctualAd, Day.wed)).toBe(
  //     '10:21',
  //   );
  //   punctualAd.departure = new Date('05-04-2023 11:06:00');
  //   expect(frequencyNormalizer.scheduleResolver(punctualAd, Day.thu)).toBe(
  //     '11:06',
  //   );
  //   punctualAd.departure = new Date('05-05-2023 05:20');
  //   expect(frequencyNormalizer.scheduleResolver(punctualAd, Day.fri)).toBe(
  //     '05:20',
  //   );
  //   punctualAd.departure = new Date('05-06-2023');
  //   expect(frequencyNormalizer.scheduleResolver(punctualAd, Day.sat)).toBe(
  //     '00:00',
  //   );
  //   punctualAd.departure = new Date('05-07-2023');
  //   expect(frequencyNormalizer.scheduleResolver(punctualAd, Day.sun)).toBe(
  //     '00:00',
  //   );
  // });
});
