import { intToFrequency } from '../../../core/dtos/validators/frequency.mapping';
import { Frequency } from '../../../interface/commands/frequency.enum';

describe('frequency mapping function ', () => {
  it('should return punctual', () => {
    expect(intToFrequency(1)).toBe(Frequency.PUNCTUAL);
  });
  it('should return recurrent', () => {
    expect(intToFrequency(2)).toBe(Frequency.RECURRENT);
  });
  it('should throw an error if frequency is unknown', () => {
    expect(() => intToFrequency(0)).toThrow();
    expect(() => intToFrequency(3)).toThrow();
  });
});
